#
# spec file for package cryptsetup
#
# Copyright (c) 2012 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


#define beta rc1
%define ver %version%{?beta:-%beta}

Name:           cryptsetup
Url:            http://code.google.com/p/cryptsetup/
BuildRequires:  device-mapper-devel
BuildRequires:  e2fsprogs-devel
BuildRequires:  libgcrypt-devel
BuildRequires:  libselinux-devel
BuildRequires:  libtool
BuildRequires:  pkgconfig
BuildRequires:  popt-devel
# hashalot version
%define haver 0.3 
# boot.crypto version
%define bcver 0_201110101134
Version:        1.4.1
Release:        0
#Release:        %{?beta:0.}<CI_CNT>.<B_CNT>%{?beta:.}%{?beta}
Summary:        Set Up dm-crypt Based Encrypted Block Devices
License:        GPL-2.0+
Group:          System/Base
Source:         http://cryptsetup.googlecode.com/files/cryptsetup-%{ver}.tar.bz2
Source1:        http://cryptsetup.googlecode.com/files/cryptsetup-%{ver}.tar.bz2.asc
Source2:        baselibs.conf
Source10:       hashalot-%haver.tar.bz2
# git://gitorious.org/opensuse/boot_crypto.git
Source20:       boot.crypto-%{bcver}.tar.bz2
# use this to create the tarball from svn
Source99:       cryptsetup-mktar
#Patch0:         cryptsetup-svn131-noascii.diff
Patch10:        hashalot-fixes.diff
Patch11:        hashalot-libgcrypt.diff
Patch12:        hashalot-ctrl-d.diff
Patch13:        hashalot-timeout.diff
Patch14:        hashalot-manpage.diff
Patch15:        bug-476290_hashalot-hashlen.diff
Patch16:        hashalot-glibc210.diff
Patch17:        bootcrypto_filestousr.diff
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
Provides:       aaa_base:/etc/init.d/boot.crypto
Obsoletes:      util-linux-crypto <= 2.12r
# we need losetup
Requires:       util-linux
PreReq:         %fillup_prereq %insserv_prereq
PreReq:         coreutils diffutils

%description
cryptsetup is used to conveniently set up dm-crypt based device-mapper
targets. It allows to set up targets to read cryptoloop compatible
volumes as well as LUKS formatted ones. The package additionally
includes support for automatically setting up encrypted volumes at boot
time via the config file /etc/crypttab.

%package -n libcryptsetup4
Summary:        Set Up dm-crypt Based Encrypted Block Devices
Group:          System/Base

%description  -n libcryptsetup4
cryptsetup is used to conveniently set up dm-crypt based device-mapper
targets. It allows to set up targets to read cryptoloop compatible
volumes as well as LUKS formatted ones. The package additionally
includes support for automatically setting up encrypted volumes at boot
time via the config file /etc/crypttab.

%package -n libcryptsetup-devel
Summary:        Set Up dm-crypt Based Encrypted Block Devices
Group:          Development/Libraries/C and C++
# cryptsetup-devel last used 11.1
Provides:       cryptsetup-devel = %{version}
Obsoletes:      cryptsetup-devel < %{version}
Requires:       libcryptsetup4 = %{version}
Requires:       device-mapper-devel libgcrypt-devel libgpg-error-devel e2fsprogs-devel glibc-devel

%description  -n libcryptsetup-devel
cryptsetup is used to conveniently set up dm-crypt based device-mapper
targets. It allows to set up targets to read cryptoloop compatible
volumes as well as LUKS formatted ones. The package additionally
includes support for automatically setting up encrypted volumes at boot
time via the config file /etc/crypttab.

%prep
%setup -n %name-%ver -q -b 10 -b 20
#patch0 -p1
pushd ../hashalot-%haver
%patch10 -p1
%patch11 -p1
%patch12 -p1
%patch13 -p1
%patch14 -p1
%patch15 -p1
%patch16 -p1
popd
pushd ../boot.crypto-%bcver
%patch17 -p1
popd

%build
# cryptsetup build
%{?suse_update_config:%{suse_update_config}}
autoreconf -f -i
test -e po/Makevars || cp po/Makevars.template po/Makevars
%configure \
				    --disable-static --enable-shared \
				    --enable-selinux
make %{?_smp_mflags}
#
# hashalot build
pushd ../hashalot-%haver
autoreconf -f -i
%{?suse_update_config:%{suse_update_config}}
%configure
make %{?_smp_mflags}
popd

%install
make install DESTDIR=$RPM_BUILD_ROOT
rm -f $RPM_BUILD_ROOT/%_libdir/*.la
# hashalot install
pushd ../hashalot-%haver
make install DESTDIR=$RPM_BUILD_ROOT
popd
# remove unwanted symlinks
rm -f $RPM_BUILD_ROOT/%{_sbindir}/{rmd160,sha256,sha384,sha512}
##
## boot.crypto
make -C ../boot.crypto-* install DESTDIR=$RPM_BUILD_ROOT
ln -s /etc/init.d/boot.crypto $RPM_BUILD_ROOT/%{_sbindir}/rccrypto
#
#UsrMerge
mkdir -p $RPM_BUILD_ROOT/{lib,sbin}
ln -sf %{_sbindir}/{cryptsetup,hashalot} $RPM_BUILD_ROOT/sbin
ln -sf /etc/init.d/boot.crypto $RPM_BUILD_ROOT/sbin/rccrypto
pushd $RPM_BUILD_ROOT/usr/lib
  ln -s mkinitdir ../../lib
  ln -s cryptsetup ../../lib
popd
#EndUserMerge
%find_lang %name --all-name

%pre
# hack to catch update case from aaa_base/util-linux-crypto
if [ -f /etc/init.d/boot.d/S??boot.crypto ]; then
	touch /var/run/cryptsetup.boot.crypto.enabled
fi

%post
[ -x /sbin/mkinitrd_setup ] && mkinitrd_setup
%{fillup_and_insserv boot.crypto}
if [ -e /var/run/cryptsetup.boot.crypto.enabled ]; then
	rm -f /var/run/cryptsetup.boot.crypto.enabled
	%{fillup_and_insserv -fY boot.crypto}
fi
%{fillup_and_insserv boot.crypto-early}
#
# convert noauto to nofail and turn on fsck (bnc#724113)
#
marker="/var/adm/crypsetup.fstab.noauto_converted"
if [ "$FIRST_ARG" -gt 1 -a ! -e "$marker" ]; then
	echo "updating /etc/fstab ... "
	tmpfstab="/etc/fstab.cryptsetup.$$"
	sed -e '/^\/dev\/mapper\/cr_.*,noauto\s/{s/,noauto\(\s\)/,nofail\1/;s/ 0 0$/ 0 2/}' < /etc/fstab > "$tmpfstab"
	if diff -u0 /etc/fstab "$tmpfstab"; then
		echo "no change"
		rm -f "$tmpfstab"
		> "$marker"
	else
		cp "$tmpfstab" "$marker"
		mv "$tmpfstab" /etc/fstab
	fi
fi

%postun
[ -x /sbin/mkinitrd_setup ] && mkinitrd_setup
%{insserv_cleanup}

%post -n libcryptsetup4 -p /sbin/ldconfig

%postun -n libcryptsetup4 -p /sbin/ldconfig

%files -f %name.lang
%defattr(-,root,root)
%ghost %verify(not md5 size mtime) %config(noreplace,missingok) /etc/crypttab
%ghost %verify(not md5 size mtime) %config(noreplace,missingok) /etc/cryptotab
/etc/init.d/boot.crypto
/etc/init.d/boot.crypto-early
%_sbindir/convert_cryptotab
%_sbindir/cryptsetup
%_sbindir/hashalot
%_sbindir/rccrypto
%dir /usr/lib/mkinitrd
%dir /usr/lib/mkinitrd/scripts
/usr/lib/mkinitrd/scripts/setup-luks.sh
/usr/lib/mkinitrd/scripts/boot-luks.sh
/usr/lib/mkinitrd/scripts/setup-luks2.sh
/usr/lib/mkinitrd/scripts/setup-luks_final.sh
/usr/lib/cryptsetup
%_mandir/man1/hashalot.1.gz
%_mandir/man8/cryptsetup.8.gz
%_mandir/man5/crypttab.5.gz
%_mandir/man5/cryptotab.5.gz
#UsrMerge
/sbin/cryptsetup
/sbin/hashalot
/sbin/rccrypto
/lib/cryptsetup
/lib/mkinitdir
#EndUserMerge

%files -n libcryptsetup4
%defattr(-,root,root)
%_libdir/libcryptsetup.so.4*

%files -n libcryptsetup-devel
%defattr(-,root,root)
%_includedir/libcryptsetup.h
%{_libdir}/libcryptsetup.so
%{_libdir}/pkgconfig/*

%changelog
